=== external/sundials-addon-example/CMakeLists.txt ===
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2025, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------

cmake_minimum_required(VERSION 3.18)
project(example-sundials-addon)

# Create mynvector library
sundials_add_library(
  sundials_external_mynvector
  SOURCES myNVector.c
  HEADERS myNVector.h
  INCLUDE_SUBDIR nvector
  LINK_LIBRARIES PUBLIC sundials_core
  OUTPUT_NAME sundials_external_mynvector)
